package asp;

import java.io.StreamTokenizer;
import java.io.StringReader;


/**
 * 
 * @author Alexander Häusler
 * @author Marco Müller
 *
 */
public class Step {
	public NonTerminal term;
	
	
	Step(NonTerminal term) {
		this.term = term;
	}
	
	/**
	 * @return The GDL representation of this object.
	 */
	public String toGDLString() {
		String temp = term.toGDLString().toUpperCase();
		
		if (temp.matches("\\(\\S+\\)"))
			return temp.substring(1,temp.length()-1);
		else 
			return temp;
	}
	
	/**
	 * @return The ASP representation of this object.
	 */
	public String toASPString() {
		return term.toASPString() + ".";
	}
	
	
	public static Step parseGDLString(String gdl) {
		Step step = null;
		gdl = gdl.toLowerCase();
		
		try {
			StreamTokenizer tokenizer = new StreamTokenizer(new StringReader(gdl.trim()));
			
			if (tokenizer.nextToken() != '(')
				throw new Exception("GDL string could not be parsed");
	
			step = new Step(NonTerminal.parseGDLString(tokenizer));
		} catch(Exception e) { }
		
		return step;
	}
	
	
	public static Step parseASPString(String asp) {
		try {
			StreamTokenizer tokenizer = new StreamTokenizer(new StringReader(asp));
			tokenizer.nextToken();
			return new Step(NonTerminal.parseASPString(tokenizer.sval, tokenizer));
			
		} catch(Exception e) {
			System.err.println("ASP string could not be parsed");
			return null;
		}
	}
}