package asp;

/**
 * 
 * @author Alexander Häusler
 * @author Marco Müller
 *
 */
public abstract class Term {
	
	private boolean terminal;
	
	/**
	 * Subclasses must set the terminal property.
	 * 
	 * @param terminal Indicates weather the subclass is a terminal or a nonterminal symbol 
	 */
	Term(boolean terminal) {
		this.terminal = terminal;
	}
	
	
	public boolean isTerminal() {
		return this.terminal;
	}
	
	
	abstract public String toGDLString();
	abstract public String toASPString();
}
