package basic;

import java.io.IOException;

import basic.GamePlayer;

/**
 * Centurio a General Game Player
 *
 * Copyright (C) 2008 Felix Maximilian M�ller, Marius Schneider and Martin Wegner
 *
 * This file is part of Centurio.
 *
 * Centurio is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
 *
 * Centurio is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with Centurio. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * This class is responsible for starting the Basicplayer.
 *
 */


public class BasicStarter {

	/**
	 * starts the game player and waits for messages from the game master <br>
	 * Command line options: [port]
	 *
	 * @param args
	 */
	public static void main(String[] args) {

		GamePlayer gp = null;

		if(args.length == 1) {

			try {
				gp = new GamePlayer(Integer.parseInt(args[0]));
			}

			catch(NumberFormatException e) {
				System.err.println("Port argument is not a number.");
				System.exit(-1);

			} catch (IOException e) {
				System.err.println("IOException beim Starten!");
				System.exit(-1);
			}
			
			GamePlayer.saveGamePlayerObject(gp);
			gp.waitForExit();
		}
		else
			System.err.println("Port als Argument angeben!");
	}
}
