package basic.ai;

import basic.logic.Move;
import basic.logic.Role;
import basic.logic.State;

/**
 * basic General Game Player from Potsdam
 *
 * Copyright (C) 2011 Marius Schneider
 *
 * The Player is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
 *
 * The Player is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with Centurio. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * interface to implement different kinds of artificial intelligence
 * @author Marius Schneider
 *
 */
public interface AI extends Runnable {

	Object getBestMove(Role role);		/* returns the expected best move */
	void initState(State initState);
	void setNewState(Move executedMove); /* set new root of the game tree */
	
}
