package basic.logic;

import basic.prepro.STTranslator;

/**
 * basic General Game Player from Potsdam
 *
 * Copyright (C) 2011 Marius Schneider
 *
 * The Player is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
 *
 * The Player is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with Centurio. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * Encapsulates Move objects
 * 
 * @author Marius Schneider
 * @version 1.0
 */

public class Move {
	private Object name;

	public Move(Object name) {
		this.name = name;
	}

	public Object get() {
		return name;
	}

	public int hashCode() {
		return name.toString().hashCode();
	}

	public boolean equals(Object other) {
		if (other.getClass() != this.getClass())
			return false;

		Move otherMove = (Move) other;
		if (this.name.toString().compareTo(otherMove.get().toString()) == 0)
			return true;
		return false;
	}

}
