package basic.logic;

import java.util.ArrayList;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * 
 * @author David Silva Ribeaux
 * 		   Patrick Wolfien
 * 
 * Parser von Prolog in KIF.
 *
 */

/*
 * 
 * (MARK 1 1) NOOP)  -> [mark(2,3), noop]
 * (NOOP (MARK 3 2)) -> [noop, mark(3,2)]
 * 
 */
public class k2p {

	public k2p() {
		
	}
//		"NOOP (MARK 2 2))"
//		"(MARK 2 3) NOOP)"	
	/**
	 * Translate Funktion übersetzt von KIF in jpl kompatible Form
	 * @param String in, der Form "NOOP (MARK 2 2))"
	 * @return String out, der Form "[noop, mark(2,2)]
	 */
	


	public String translate(String in){
		
		ArrayList<String> a = new ArrayList<String>( );
		String help = null;
		String out = null;
		

		
		while(in.matches("\\s*NOOP.*") || in.matches(".*\\(.+\\).+")){
			if(in.matches("\\s*NOOP.+")){

				
				a.add("noop");
				
				in = in.substring(in.indexOf("P")+1);
			}
			if(in.matches("\\s*\\(.+\\).+")){
				help=in.substring(0,in.indexOf(")")+1).trim();
				help=help.replaceAll("[\\(\\)]", "");
				help=help.replaceFirst("\\s", "(");
				help=help.replaceAll("\\s",",");
				help=help+")";
				help=help.toLowerCase();
				a.add(help);

				in=in.substring(in.indexOf(")")+1);
			}
			
		}
		
		out="[";
		
		for(int i=0;i<a.size()-1;i++){
			out=out+a.get(i)+", ";
		}
			out=out+a.get(a.size()-1)+"]";
		
		return out;
		
	}
	
	
	

	
	
//	Eingabe: '.'(mark(1, 1), '.'(noop, [])) -> (MARK 1 1) NOOP)
	/**
	 * Übersetzer von jpl-Prolog Listen in KIF
	 * @param alt, der Form '.'(mark(1, 1), '.'(noop, []))
	 * @return neu, der Form (mark 1 1)
	 */
	public String translate2kif(String alt){
		alt = alt.substring(3);
		String vars[] = alt.split("'.'"); 
		
		
		for(int i=0; i < vars.length ;i++){
		//vars[i] = vars[i].substring(0, vars[i].indexOf(","));
		vars[i] = vars[i].replaceAll(",\\s\\[\\]\\)*", "");	
		
		Pattern p = Pattern.compile(".*noop.*");
		Matcher m = p.matcher(vars[i]);
		if(m.matches() == true){
			vars[i] = "noop";
		}else{
		 vars[i] = vars[i].substring(1);
		 vars[i] = vars[i].replaceAll("\\).*","");
		 vars[i] = vars[i].replaceAll("\\("," ");
		 vars[i] = vars[i].replaceAll(",","");
		 vars[i] = "("+vars[i]+")";
		}
		}
		
		String neu = vars[0];
		
		
		return neu;
		
	}
	
}

